# This file is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 2 as 
# published by the Free Software Foundation here:
# (http://www.gnu.org/licenses/gpl-2.0.html)
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

export SRCPKG = openssl
export DEPENDS = glibc
export ARCH = x86_64
export URL = https://www.openssl.org/
BRIEF = Library routines for TLS and SSL
DESC = OpenSSL is an open source project that provides a robust, \
commercial-grade, and full-featured toolkit for the Transport Layer \
Security (TLS) and Secure Sockets Layer (SSL) protocols.
SNAPVER = 2

ARCHIVE := $(PWD)/SRC/$(shell ls SRC|egrep '(bz2|gz|tar|xz)$$'|tail -1)
TYPE := $(shell file -ib $(ARCHIVE)|cut -d';' -f1|tr -d '\n')
SRCDIR := $(shell tar -tf $(ARCHIVE)|head -1|sed 's/\/.*//')
PATCHDIR := $(PWD)/SRC/patches
export VERSION := $(shell echo $(SRCDIR)|egrep -o '\-[0-9].*'| \
	sed 's/^-//')-$(SNAPVER)

DEV := $(PWD)/openssl-dev
DEVROOT := $(DEV)/ROOT

include /usr/share/snap/Makefile.snaplinux

$(SRCDIR)/config: $(ARCHIVE)
	@if [ '$(TYPE)' == 'application/x-bzip2' ]; then \
		tar -jxf $(ARCHIVE); \
	elif [ '$(TYPE)' == 'application/x-gzip' ]; then \
		tar -zxf $(ARCHIVE); \
	elif [ '$(TYPE)' == 'application/x-tar' ]; then \
		tar -xf $(ARCHIVE); \
	elif [ '$(TYPE)' == 'application/x-xz' ]; then \
		tar -xf $(ARCHIVE); \
	else \
		echo 'Unable to determine archive type'; \
		exit 1; \
	fi
	@touch $(SRCDIR)/config

$(SRCDIR)/config.log: $(SRCDIR)/config
	@cd $(SRCDIR) && \
	for patch in `find $(PATCHDIR) -name \*.patch|sort`; do \
		patch --verbose -Np0 -i $$patch; \
	done
	@cd $(SRCDIR); \
	./config \
		--prefix=/usr \
		--openssldir=/etc/ssl \
		--libdir=lib \
		shared \
		zlib-dynamic

$(SRCDIR)/apps/openssl: $(SRCDIR)/config.log
	@cd $(SRCDIR) && make depend && make

$(ROOT): $(SRCDIR)/apps/openssl
	@if [ -d $(ROOT) ]; then \
		touch $(ROOT); \
	else \
		mkdir -v $(ROOT); \
	fi

	@cd $(SRCDIR) && make MANDIR=/usr/share/man install \
		INSTALL_PREFIX=$(ROOT)

	@install -v -d $(DEV)/SNAP && \
	install -v -d $(DEVROOT) && \
	install -d -v -m 755 $(DEVROOT)/usr/share/doc/openssl && \
	cp -vr $(SRCDIR)/doc/* $(DEVROOT)/usr/share/doc/openssl && \
	for file in `find $(ROOT)|egrep 'man3\/|pkgconfig\/|\.a$$|\.h$$'`; do \
		path=`dirname $$file|sed "s[$(ROOT)[$(DEVROOT)["`; \
		mkdir -p $$path; \
		mv $$file $$path; \
	done && \
	find $(ROOT) -type d -empty -delete && \
	cd $(DEV) && make -f ../Makefile.openssl-dev && mv *.snap ../

test: $(ROOT)
	@cd $(SRCDIR); \
	make -j1 test

clean:
	@rm -rvf $(ROOT) \
		$(DEV) \
		$(SNAPINFO) \
		$(MANIFEST) \
		$(FILES) \
		$(SRCDIR)

